OpenTTD: VideoDriver_Win32 Class Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions
VideoDriver_Win32 Class Reference

The video driver for windows. More...

`#include <win32_v.h>`

Inheritance diagram for VideoDriver_Win32:

## Public Member Functions
const char * | Start (const char *const *param)
| Start this driver.
void | Stop ()
| Stop this driver.
void | MakeDirty (int left, int top, int width, int height)
| Mark a particular area dirty.
void | MainLoop ()
| Perform the actual drawing.
bool | ChangeResolution (int w, int h)
| Change the resolution of the window.
bool | ToggleFullscreen (bool fullscreen)
| Change the full screen setting.
bool | AfterBlitterChange ()
| Callback invoked after the blitter was changed.
void | AcquireBlitterLock ()
| Acquire any lock(s) required to be held when changing blitters.
void | ReleaseBlitterLock ()
| Release any lock(s) required to be held when changing blitters.
bool | ClaimMousePointer ()
void | EditBoxLostFocus ()
| An edit box lost the input focus.
const char * | GetName () const
| Get the name of this driver.
bool | MakeWindow (bool full_screen)
| Instantiate a new window.
Public Member Functions inherited from VideoDriver
virtual bool | HasGUI () const
| Whether the driver has a graphical user interface with the end user.

## Additional Inherited Members
Public Types inherited from Driver
enum | Type { DT_BEGIN = 0, DT_MUSIC = 0, DT_SOUND, DT_VIDEO, DT_END }
| The type of driver. More...
Static Public Member Functions inherited from VideoDriver
static VideoDriver * | GetInstance ()
| Get the currently active instance of the video driver.

## Detailed Description

The video driver for windows.

Definition at line 18 of file win32_v.h.

## Member Function Documentation

void VideoDriver_Win32::AcquireBlitterLock | ( |  | ) |
| virtual

Acquire any lock(s) required to be held when changing blitters.

These lock(s) may not be acquired recursively.

Reimplemented from VideoDriver.

Definition at line 1340 of file win32_v.cpp.

References ThreadMutex::BeginCritical().

bool VideoDriver_Win32::AfterBlitterChange | ( |  | ) |
| virtual

Callback invoked after the blitter was changed.

This may only be called between AcquireBlitterLock and ReleaseBlitterLock.

Returns
  True if no error.

Reimplemented from VideoDriver.

Definition at line 1335 of file win32_v.cpp.

References MakeWindow().

bool VideoDriver_Win32::ChangeResolution | ( | int | w,
|  | int | h
| ) |  |
| virtual

Change the resolution of the window.

Parameters

  w | The new width.
  h | The new height.

Returns
  True if the change succeeded.

Implements VideoDriver.

Definition at line 1314 of file win32_v.cpp.

References ThreadMutex::BeginCritical(), ThreadMutex::EndCritical(), and MakeWindow().

Referenced by MakeWindow().

void VideoDriver_Win32::EditBoxLostFocus | ( |  | ) |
| virtual

An edit box lost the input focus.

Abort character compositing if necessary.

Reimplemented from VideoDriver.

Definition at line 1350 of file win32_v.cpp.

References ThreadMutex::BeginCritical(), CancelIMEComposition(), ThreadMutex::EndCritical(), SetCandidatePos(), and SetCompositionPos().

const char* VideoDriver_Win32::GetName | ( |  | ) | const
| inlinevirtual

Get the name of this driver.

Returns
  The name of the driver.

Implements Driver.

Definition at line 42 of file win32_v.h.

void VideoDriver_Win32::MakeDirty | ( | int | left,
|  | int | top,
|  | int | width,
|  | int | height
| ) |  |
| virtual

Mark a particular area dirty.

Parameters

  left | The left most line of the dirty area.
  top | The top most line of the dirty area.
  width | The width of the dirty area.
  height | The height of the dirty area.

Implements VideoDriver.

Definition at line 1171 of file win32_v.cpp.

bool VideoDriver_Win32::MakeWindow | ( | bool | full_screen | ) |

Instantiate a new window.

Parameters

  full_screen | Whether to make a full screen window or not.

Returns
  True if the window could be created.

Definition at line 258 of file win32_v.cpp.

References ChangeResolution(), GameSizeChanged(), BlitterFactory::GetCurrentBlitter(), Blitter::GetScreenDepth(), lengthof, Blitter::PostResize(), S8BPP_HARDWARE, and usererror().

Referenced by AfterBlitterChange(), ChangeResolution(), Start(), and ToggleFullscreen().

void VideoDriver_Win32::ReleaseBlitterLock | ( |  | ) |
| virtual

Release any lock(s) required to be held when changing blitters.

These lock(s) may not be acquired recursively.

Reimplemented from VideoDriver.

Definition at line 1345 of file win32_v.cpp.

References ThreadMutex::EndCritical().

const char * VideoDriver_Win32::Start | ( | const char *const * | parm | ) |
| virtual

Start this driver.

Parameters

  parm | Parameters passed to the driver.

Returns
  NULL if everything went okay, otherwise an error message.

Implements Driver.

Definition at line 1133 of file win32_v.cpp.

References _cur_resolution, _draw_threaded, DEBUG, GetCPUCoreCount(), GetDriverParam(), MakeWindow(), and MarkWholeScreenDirty().

bool VideoDriver_Win32::ToggleFullscreen | ( | bool | fullscreen | ) |
| virtual

Change the full screen setting.

Parameters

  fullscreen | The new setting.

Returns
  True if the change succeeded.

Implements VideoDriver.

Definition at line 1327 of file win32_v.cpp.

References ThreadMutex::BeginCritical(), ThreadMutex::EndCritical(), and MakeWindow().

The documentation for this class was generated from the following files:

- src/video/win32_v.h
- src/video/win32_v.cpp